(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('firebase/app')) :
    typeof define === 'function' && define.amd ? define('ngx-timestamp-date', ['exports', '@angular/core', 'firebase/app'], factory) :
    (global = global || self, factory(global['ngx-timestamp-date'] = {}, global.ng.core, global.app));
}(this, (function (exports, core, app) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/service/ngx-timestamp-date.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxTimestampDateService = /** @class */ (function () {
        function NgxTimestampDateService() {
        }
        /**
         * @return {?}
         */
        NgxTimestampDateService.prototype.getServerTimestamp = /**
         * @return {?}
         */
        function () {
            return app.firestore.Timestamp.now();
        };
        /**
         * @return {?}
         */
        NgxTimestampDateService.prototype.getServerDate = /**
         * @return {?}
         */
        function () {
            return this.getServerTimestamp().toDate();
        };
        /**
         * @param {?} timestamp
         * @return {?}
         */
        NgxTimestampDateService.prototype.timestampToDate = /**
         * @param {?} timestamp
         * @return {?}
         */
        function (timestamp) {
            /** @type {?} */
            var date = (/** @type {?} */ (timestamp));
            return date.toDate();
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NgxTimestampDateService.prototype.dateToTimestamp = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return app.firestore.Timestamp.fromDate(date);
        };
        /**
         * @template T
         * @param {?} data
         * @return {?}
         */
        NgxTimestampDateService.prototype.parseTimestampToDate = /**
         * @template T
         * @param {?} data
         * @return {?}
         */
        function (data) {
            var _this = this;
            /** @type {?} */
            var doc = data;
            if (doc) {
                if (Array.isArray(doc)) {
                    doc = doc.map(this.checkPropertyValue.bind(this));
                }
                if (doc.constructor.name === 'Object') {
                    Object.keys(doc).forEach((/**
                     * @param {?} key
                     * @return {?}
                     */
                    function (key) {
                        doc[key] = _this.checkPropertyValue(doc[key]);
                    }));
                }
            }
            return doc;
        };
        /**
         * @private
         * @param {?} element
         * @return {?}
         */
        NgxTimestampDateService.prototype.checkPropertyValue = /**
         * @private
         * @param {?} element
         * @return {?}
         */
        function (element) {
            if (element) {
                if ((element._seconds >= 0 || element.seconds >= 0) &&
                    (element._nanoseconds >= 0 || element.nanoseconds >= 0)) {
                    element = new Date((element._seconds || element.seconds) * 1000);
                }
                else {
                    element = this.parseTimestampToDate(element);
                }
            }
            return element;
        };
        NgxTimestampDateService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        NgxTimestampDateService.ctorParameters = function () { return []; };
        /** @nocollapse */ NgxTimestampDateService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function NgxTimestampDateService_Factory() { return new NgxTimestampDateService(); }, token: NgxTimestampDateService, providedIn: "root" });
        return NgxTimestampDateService;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/components/ngx-timestamp-date.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxTimestampDateComponent = /** @class */ (function () {
        function NgxTimestampDateComponent() {
        }
        /**
         * @return {?}
         */
        NgxTimestampDateComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        NgxTimestampDateComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-ngx-timestamp-date',
                        template: "\n    <p>\n      ngx-timestamp-date works!\n    </p>\n  "
                    }] }
        ];
        /** @nocollapse */
        NgxTimestampDateComponent.ctorParameters = function () { return []; };
        return NgxTimestampDateComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-timestamp-date.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxTimestampDateModule = /** @class */ (function () {
        function NgxTimestampDateModule() {
        }
        NgxTimestampDateModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            NgxTimestampDateComponent
                        ],
                        imports: [],
                        exports: [
                            NgxTimestampDateComponent
                        ],
                        providers: [
                            NgxTimestampDateService
                        ]
                    },] }
        ];
        return NgxTimestampDateModule;
    }());

    exports.NgxTimestampDateComponent = NgxTimestampDateComponent;
    exports.NgxTimestampDateModule = NgxTimestampDateModule;
    exports.NgxTimestampDateService = NgxTimestampDateService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-timestamp-date.umd.js.map
